<template>
  <div>
    <!--Stats cards-->
    <div class="row">
      <div class="col-md-6 col-xl-3" v-for="stats in statsCards" :key="stats.title">
        <stats-card>
          <div class="icon-big text-center" :class="`${stats.type}`" slot="header">
            <i :class="stats.icon"></i>
          </div>
          <div class="numbers" slot="content">
            <p>{{stats.title}}</p>
            {{stats.value}}
          </div>
          <div class="stats" slot="footer">
            <i :class="stats.footerIcon"></i> {{stats.footerText}}
          </div>
        </stats-card>
      </div>
    </div>
    <hr />
  <div class="row">
    <div class="col-12">
      <select class="form-control form-control-sm" v-model="monthsModel" v-on:change="getStatisticCharts">
      <option v-for="x in monthsOptions" :value="x.value">{{x.display}}</option>
      </select>
    </div>
    <div class="col-12" v-if="loadingGraph==false">
    <highcharts :options="lineChartsOptions"></highcharts>
    </div>
    <div class="col-12" v-if="loadingGraph">
      <div class="text-center">
       <div class="spinner-border" role="status">
                    <span class="sr-only">Loading...</span>
                  </div>
      </div>
      </div>
  </div>
  <div class="clearfix">&nbsp;</div>
  <div class="row">
    <div class="col-xs-12 col-md-3">
      <h5>{{tableCovidStatus}}&nbsp;<br><small>{{tableCovidStatusUpdate}}</small></h5>
        <div class="card">
               
        <div class="card-body">

            <table class="table table-striped">
              <thead>
              <tr>
              <th><div class="text-center"><a href="javascript:void(0);" @click="sortProvice">จังหวัด</a></div></th>
              <th><div class="text-right"><a href="javascript:void(0);" @click="sortProviceTotalType">จำนวน</a></div></th>
              </tr>
              </thead>
              <tbody v-if="loadingProvince==false">
              <tr v-for="(data,index) in orderByProvinceTable">
                <td>{{data.provinceNameTH}}</td>
                <td><div class="text-right text-bold">{{data.totals.toLocaleString()}}</div></td>
              </tr>
              </tbody>
              <tbody v-if="loadingProvince">
              <tr>
                  <td colspan="2">
                  <div class="spinner-border" role="status">
                    <span class="sr-only">Loading...</span>
                  </div>
                  </td>
                </tr>
              </tbody>
            </table>
        </div>
         </div>
      </div>
    <div class="col-xs-12 col-md-9">
           <h5>พื้นที่แจ้งเตือน</h5>
           <div class="row" v-if="loadingAnnounce==false && lsCovidAnnounces.length>0">

                <div class="col-6"  v-for="x in lsCovidAnnounces">
                    <div class="card border-primary">
                    <div class="card-header bg-light">
                      {{x.Date}}  เวลา {{x.Time}}
                    </div>
                      <div class="card-body">
                    
                        <div class="card-text">สถานที่ -{{x.Location}}</div>
                        <div class="card-text">คำประกาศ <span v-html="x.Recommend"></span></div>
                        <div>ประกาศโดย - {{x.AnnounceBy}}</div>
                        <div>จังหวัด - {{x.Province}} วันที่ {{x.Update}}</div>
                            
                        </div>
                      </div>

                  </div>
          
          </div>
          <div class="row" v-if="lsCovidAnnounces==0">
              <h5>ไม่มีประกาศใหม่</h5>
          </div>
          <div class="row" v-if="loadingAnnounce">
             <div class="spinner-border" role="status">
                    <span class="sr-only">Loading...</span>
                  </div>
          </div>
          <a class="btn btn-primary text-white col-12"  v-on:click="getCovidAreaAnnounceMore()" v-if="pageAnnounceCovidAnnounce<pageAnnounceCovidAll && pageAnnounceCovidAll>6">แสดงเพิ่มเติม</a>
    </div>
    </div>
    <div class="row">
      <div class="col-12">
          <h6>Source</h6>
          <ul>
              <li><a href="http://covid19.th-stat.com/" target="_blank">กรมควบคุมโรค</a></li>
          </ul>
        </div>
      </div>
  
      <b-modal id="my-modal" size="xl" v-model="modalShow" hide-footer> 
          <template v-slot:modal-title>
        Using <code>$bvModal</code> Methods
      </template>
      <div class="d-block text-center">
        <h3>Hello From This Modal!</h3>
      </div>
      <b-button class="mt-3" block >Close Me</b-button>
    </b-modal>



  </div>
</template>
<script>

import { StatsCard, ChartCard,PaperTable } from "@/components/index";
import axios from 'axios';
import Highcharts from 'highcharts';
import {Chart} from 'highcharts-vue';
import { BModal, VBModal } from 'bootstrap-vue'

import Chartist from 'chartist';
 Highcharts.setOptions({
        lang: {
            thousandsSep: ',',
            decimalPoint: '.'
        }
    });
export default {
  components: {
    StatsCard,
    ChartCard,
    PaperTable,
    highcharts : Chart,
    'b-modal':BModal
  },
 
  data() {
    return {
      monthsOptions:[],
      titleStatus :"",
      tableCovidStatus :"ภาพรวมสถานการณ์ติดเชื้อโควิด",
      tableCovidStatusUpdate :"",
      tableCovidStatusColumn:["province","totals"],
      tableCovidStatusDatas:[],
      lsCovidAnnounces:[],
      lineChartsOptions:{},
      lsCovindAnnouncesAll:[],
      pageAnnounceCovidAll:0,
      pageAnnounceCovidAnnounce:0,
      monthsModel:"",
      convidToday:{},
      statsCards: [],
      modalShow:false,
      tableCovidColumnSortBy:"desc",
       tableCovidProvinceColumnSortBy:"asc",
       tableCovidcolumnSearch : "totals",
       loadingGraph:false,
        loadingProvince:false,
        loadingAnnounce:false,
        urlHost:"http://contents.i8app.net/"
        //urlHost:"http://localhost:57572/"
    };
  },
  computed:{
    orderByProvinceTable:function(){
      return _.orderBy(this.tableCovidStatusDatas,this.tableCovidcolumnSearch,this.tableCovidColumnSortBy)
    }
  },
  methods :{
    sortProviceTotalType:function(){
      this.tableCovidcolumnSearch="totals"

      this.tableCovidColumnSortBy =(this.tableCovidColumnSortBy=="desc" ? "asc" : "desc")
    }, 
     sortProvice:function(){
       this.tableCovidcolumnSearch="provinceNameTH"
      this.tableCovidColumnSortBy =(this.tableCovidColumnSortBy=="desc" ? "asc" : "desc")
    },
    showModal:function() {
        this.modalShow=true
      },
    getOptionsMonth: function(){
         var monthNamesThai = ["มกราคม","กุมภาพันธ์","มีนาคม","เมษายน","พฤษภาคม","มิถุนายน",
"กรกฎาคม","สิงหาคม","กันยายน","ตุลาคม","พฤษจิกายน","ธันวาคม"];
        var dt = new Date()
        var years = dt.getFullYear()
        var aryMonthPicker =[]
        for(var i=1;i<=monthNamesThai.length;i++){
            var data = {
                value : i+'/'+years,
                display : monthNamesThai[i-1]+' '+years
            };
            aryMonthPicker.push(data)
        }
        this.monthsOptions = aryMonthPicker

    },
    getTodayStats : function(){
        this.loadingGraph=true;
        var constUrl = "https://covid19.th-stat.com/api/open/today"
          axios
            .get(constUrl)
            .then(response => {
                this.loadingGraph=false
                if(response.status==200){
                  this.convidToday = response.data
                  this.statsCards=[]
                  this.statsCards=[ {
                      type: "info",
                      icon: "fa fa-laptop-house text-info",
                      title: "ยอดผู้ติดเชื้อ",
                      value: this.convidToday.Confirmed.toLocaleString() +"("+this.convidToday.NewConfirmed+")",
                      footerText: this.convidToday.UpdateDate,
                      footerIcon : "fa fa-pen-alt"
                    },
                    {
                      type: "info",
                      icon: "fa fa-virus-slash text-success",
                      title: "รักษาหาย",
                      value: this.convidToday.Recovered.toLocaleString()+"("+this.convidToday.NewRecovered+")",
                      footerText: this.convidToday.UpdateDate,
                       footerIcon : "fa fa-pen-alt"
                    },
                    {
                      type: "warning",
                      icon: "fa fa-hospital-user text-warning",
                      title: "รักษาตัว",
                      value: this.convidToday.Hospitalized.toLocaleString()+"("+this.convidToday.NewHospitalized+")",
                      footerText: this.convidToday.UpdateDate,
                       footerIcon : "fa fa-pen-alt"
                    }
                    ,
                    {
                      type: "danger",
                      icon: "fa fa-hospital-user text-danger",
                      title: "เสียชีวิต",
                      value: this.convidToday.Deaths+"("+this.convidToday.NewDeaths+")",
                      footerText: this.convidToday.UpdateDate,
                       footerIcon : "fa fa-pen-alt"
                    }]
                }
               
            })
            .catch(error => {
                this.loadingGraph=false
                console.log(error)

            })
    },
    getNameThai :function(param){
       var monthNamesThai = ["มกราคม","กุมภาพันธ์","มีนาคม","เมษายน","พฤษภาคม","มิถุนายน",
"กรกฎาคม","สิงหาคม","กันยายน","ตุลาคม","พฤษจิกายน","ธันวาคม"];
      var arySplit = param.split('/')
      var result = arySplit[0]+ " "+ monthNamesThai[parseInt(arySplit[1])]+" "+arySplit[2]
      return result
    },
    
    getProvinceStatistic(){
        this.loadingProvince=true
        
          let urlGet =this.urlHost+"api/CovidtrackerAPI/GetSummaryByCase"
          axios
            .get(urlGet)
            .then(response => {
               
                this.loadingProvince=false
                if(response.status==200){
                  var dateUpdate =response.data.dateThaiUpdate
                  this.tableCovidStatusUpdate= dateUpdate
                  this.tableCovidStatusDatas= response.data.provinces

                }
               
            })
            .catch(error => {
                this.loadingProvince=false
                console.log(error)

            })
       
    },
    getStatisticCharts : function(){

        this.lineChartsOptions={}

          this.loadingGraph=true
          let urlGet =this.urlHost+"api/CovidtrackerAPI/GetStatiscByMonthCase"
          
          var objData = {"monthYear": this.monthsModel}
          axios
            .post(urlGet,objData)
            .then(response => {
              this.loadingGraph=false
                var objResult = response.data
                if(response.status==200){
                      this.lineChartsOptions={
                      
                      chart: {
                          type: 'line'
                      },
                      title: {
                          text: objResult.yAxisTitle
                      },
                      xAxis: {
                          categories: objResult.categoriesName
                      },
                      yAxis: {
                          title: {
                              text: 'จำนวนคน'
                          },
                          
                      },
                    
                      plotOptions: {
                          line: {
                              dataLabels: {
                                  enabled: true
                              },
                              enableMouseTracking: true,
                              
                          }
                      },
                      series: objResult.series
                    }
                }
               
            })
            .catch(error => {
              this.loadingGraph=false
                console.log(error)

            })
    },
     getCovidAreaAnnounce :function(){
        this.loadingAnnounce=true
          let urlGet ="https://covid19.th-stat.com/api/open/area"
          axios
            .get(urlGet)
            .then(response => {
      
                this.loadingAnnounce=false
                if(response.status==200){
            
                  var dateUpdate =response.data.UpdateDate
                  var rowsCount = response.data.Data.length
                  if(rowsCount >0){
                        this.pageAnnounceCovidAll= rowsCount
                                          this.pageAnnounceCovidAnnounce=1;
                                          this.lsCovindAnnouncesAll= response.data.Data;
                                          for(var i =0;i<=5;i++){
                                                if(response.data.Data[i]!=null){
                                                  this.lsCovidAnnounces.push(response.data.Data[i])
                                                }
                                        
                                          }
                  }
                  else{
                    this.pageAnnounceCovidAll=0
                    this.pageAnnounceCovidAnnounce=0;
                    this.lsCovindAnnouncesAll=[]
                    this.lsCovidAnnounces=[]
                  }
                 
                }
               
            })
            .catch(error => {
               this.loadingAnnounce=false
                console.log(error)

            })
       
    },
    getCovidAreaAnnounceMore :function(){
        if(this.lsCovindAnnouncesAll==null) return;
        
        if(this.pageAnnounceCovidAnnounce < this.pageAnnounceCovidAll){
          var iStart = this.pageAnnounceCovidAnnounce+4;
          var iFinish =(parseInt(this.pageAnnounceCovidAnnounce)+parseInt(4*2))
          if(iFinish > this.pageAnnounceCovidAll) iFinish=this.pageAnnounceCovidAll
         
          for(var i =iStart;i<iFinish;i++){
                var obj =this.lsCovindAnnouncesAll[i]
                if(obj==null || i>this.lsCovindAnnouncesAll.length) continue;
              
                        this.lsCovidAnnounces.push(obj)
          }
          this.pageAnnounceCovidAnnounce+=5;
            
        }
    }
  },
  mounted() {
     this.getTodayStats()
     this.getCovidAreaAnnounce()
     this.getOptionsMonth()
      this.getProvinceStatistic()
    if(this.monthsModel==null || this.monthsModel==""){
        var dt = new Date()
        var years = dt.getFullYear()
       
        var months = dt.getMonth()+1
        this.monthsModel = months+"/"+years;
    
    }
        this.getStatisticCharts()

  },
};
</script>
<style>
</style>
